P1118 [USACO06FEB]数字三角形`Backward Digit Su`…
题目描述
FJ
and his cows enjoy playing a mental game. They write down the numbers from 11 to N(1 \le N \le 10)N(1≤N≤10) in a certain order and then sum adjacent numbers to produce a new list with one fewer number. They repeat this until only a single number is left. For example, one instance of the game (when N=4N=4 ) might go like this:
3 1 2 4
4 3 6
7 9
16
Behind FJ
's back, the cows have started playing a more difficult game, in which they try to determine the starting sequence from only the final total and the number NN . Unfortunately, the game is a bit above FJ
's mental arithmetic capabilities.
Write a program to help FJ
play the game and keep up with the cows.
有这么一个游戏:
写出一个 11 至 NN 的排列 a_iai ,然后每次将相邻两个数相加,构成新的序列,再对新序列进行这样的操作,显然每次构成的序列都比上一次的序列长度少 11 ,直到只剩下一个数字位置。下面是一个例子:
3,1,2,43,1,2,4
4,3,64,3,6
7,97,9
1616
最后得到 1616 这样一个数字。
现在想要倒着玩这样一个游戏,如果知道 NN ,知道最后得到的数字的大小 sumsum ,请你求出最初序列 a_iai ,为 11 至 NN 的一个排列。若答案有多种可能,则输出字典序最小的那一个。
[color=red]管理员注:本题描述有误,这里字典序指的是 1,2,3,4,5,6,7,8,9,10,11,121,2,3,4,5,6,7,8,9,10,11,12
而不是 1,10,11,12,2,3,4,5,6,7,8,91,10,11,12,2,3,4,5,6,7,8,9 [/color]
输入输出格式
输入格式:
两个正整数 n,sumn,sum 。
输出格式:
输出包括 11 行,为字典序最小的那个答案。
当无解的时候,请什么也不输出。(好奇葩啊)
输入输出样例
说明
对于 40\%40% 的数据, n≤7n≤7 ;
对于 80\%80% 的数据, n≤10n≤10 ;
对于 100\%100% 的数据, n≤12,sum≤12345n≤12,sum≤12345 。
Solution:
本题比较水(纯暴力就能过)。
不难发现每次合并,每个位置的数所参与的贡献次数为杨辉三角的第$n$行所对应的数。
举个例子:$a,b,c,d\rightarrow a+3b+3c+d$。最后一个数中$a,b,c,d$的系数就是杨辉三角第$4$行的数列。
所以我们可以先递推出前$12$行杨辉三角的数,然后作为系数,因为要使得前面的数值尽可能小,所以就枚举每一位的取值,随便加一个可行性剪枝(记录当前的$tot$,若大于总和$sum$则减掉),然后记录一下每个数的取值范围,乱搞一下就好了。
代码:
#include<bits/stdc++.h> #define il inline #define ll long long #define For(i,a,b) for(int (i)=(a);(i)<=(b);(i)++) #define Bor(i,a,b) for(int (i)=(b);(i)>=(a);(i)--) using namespace std; int n,sum,a[15],c[15][15]; bool f=0,vis[15]; il int gi(){ int a=0;char x=getchar();bool f=0; while((x<'0'||x>'9')&&x!='-')x=getchar(); if(x=='-')x=getchar(),f=1; while(x>='0'&&x<='9')a=(a<<3)+(a<<1)+x-48,x=getchar(); return f?-a:a; } il void init(){ c[1][1]=1; For(i,2,12) For(j,1,i) c[i][j]=c[i-1][j-1]+c[i-1][j]; } il void dfs(int now,int tot){ if(sum-tot<=0)return; if(now==n-1) if(!vis[sum-tot]&&sum-tot<=n) { a[n]=sum-tot; For(i,1,n) cout<<a[i]<<' '; exit(0); } int p=min(sum-tot,n); For(i,1,p) if(!vis[i]) { a[now+1]=i;vis[i]=1; dfs(now+1,tot+i*c[n][now+1]); vis[i]=0; } } int main(){ ios::sync_with_stdio(0); init(); n=gi(),sum=gi(); if(n==1){cout<<1;return 0;} For(i,1,n) { vis[i]=1; a[1]=i,dfs(1,i); vis[i]=0; } return 0; }